Index: /LMDZ4/trunk/libf/phylmd/moyglo_aire.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/moyglo_aire.F	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/moyglo_aire.F	(revision 644)
@@ -0,0 +1,155 @@
+      SUBROUTINE moyglo_pondaire(nhori, champ, aire, 
+     .            ok_msk, msk, moyglo)
+c
+       IMPLICIT none
+c
+c ==================================================================
+c I. Musat, 07.2004
+c
+c Calcul moyenne globale ponderee par l'aire totale, avec ou sans masque
+c
+c moyenne = Somme_(champ* aire)/Somme_aire
+c
+c ==================================================================
+c
+#include "dimensions.h"
+#include "dimphy.h"
+       INTEGER i, nhori
+       REAL champ(klon), aire(klon), msk(klon)
+       LOGICAL ok_msk 
+       REAL moyglo
+c
+c var locale
+       REAL airetot
+c
+c      PRINT*,'moyglo_pondaire nhori',nhori
+c
+       airetot=0.
+       moyglo=0.
+c
+       IF(ok_msk) THEN
+        DO i=1, nhori
+c        IF(msk(i).EQ.1.) THEN 
+         IF(msk(i).GT.0.) THEN 
+c
+c aire totale
+          airetot=airetot+aire(i)*msk(i)
+c
+c ponderation par la masse
+          moyglo=moyglo+champ(i)* aire(i)*msk(i) 
+         ENDIF
+        ENDDO
+c
+       ELSE !ok_msk
+        DO i=1, nhori
+c
+c aire totale
+          airetot=airetot+aire(i)
+c
+c ponderation par la masse
+          moyglo=moyglo+champ(i)* aire(i) 
+        ENDDO 
+c
+       ENDIF
+c 
+c moyenne ponderee par l'aire
+       moyglo=moyglo/airetot
+c
+       RETURN 
+       END
+c
+       SUBROUTINE moyglo_pondaima(nhori, nvert, champ,
+     . aire, pbord, moyglo)
+       IMPLICIT none
+c ==================================================================
+c I. Musat, 07.2004
+c
+c Calcul moyenne globale ponderee par la masse d'air, divisee par l'aire
+c totale avec ou sans masque
+c
+c moyenne = Somme_(champ* masse_dair)/Somme_aire
+c
+c ==================================================================
+#include "dimensions.h"
+#include "dimphy.h"
+#include "YOMCST.h"
+       INTEGER i, k, nhori, nvert
+       REAL champ(klon,klev), aire(klon)
+       REAL pbord(klon,klev+1)
+       REAL moyglo
+c
+c var locale
+       REAL airetot
+c
+c      PRINT*,'moyglo_pondaima RG, nhori, nvert',RG,nhori,nvert
+c
+c ponderation par la masse
+       moyglo=0.
+       DO k=1, nvert
+       DO i=1, nhori
+        moyglo=moyglo+
+     .  champ(i,k)*(pbord(i,k)-pbord(i,k+1))/RG*aire(i)
+       ENDDO
+       ENDDO
+c
+c aire totale
+       airetot=0.
+       DO i=1, nhori
+        airetot=airetot+aire(i)
+       ENDDO
+c
+c moyenne par mettre carre avec ponderation par la masse
+       moyglo=moyglo/airetot
+c
+      RETURN
+      END
+c
+       SUBROUTINE moyglo_pondmass(nhori, nvert, champ,
+     . aire, pbord, moyglo)
+       IMPLICIT none
+c ==================================================================
+c I. Musat, 07.2004
+c
+c Calcul moyenne globale ponderee par la masse d'air, divisee par la
+c masse totale d'air, avec ou sans masque
+c
+c moyenne = Somme_(champ* masse_dair)/Somme_(masse_dair)
+c
+c ==================================================================
+#include "dimensions.h"
+#include "dimphy.h"
+#include "YOMCST.h"
+       INTEGER i, k, nhori, nvert
+       REAL champ(klon,klev), aire(klon)
+       REAL pbord(klon,klev+1)
+       REAL moyglo
+c
+c var locale
+       REAL massetot
+c
+c      PRINT*,'moyglo_pondmass RG, nhori, nvert',RG,nhori,nvert
+c
+c ponderation par la masse
+       moyglo=0.
+       DO k=1, nvert
+       DO i=1, nhori
+        moyglo=moyglo+
+     .  champ(i,k)*(pbord(i,k)-pbord(i,k+1))/RG*aire(i)
+       ENDDO
+       ENDDO
+c
+c masse totale
+       massetot=0.
+       DO k=1, nvert
+       DO i=1, nhori
+        massetot=massetot+
+     .  (pbord(i,k)-pbord(i,k+1))/RG*aire(i)
+       ENDDO
+       ENDDO
+c
+c moyenne par mettre carre avec ponderation par la masse
+       moyglo=moyglo/massetot
+c
+      RETURN
+      END
+c
Index: /LMDZ4/trunk/libf/phylmd/orografi.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/orografi.F	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/orografi.F	(revision 644)
@@ -113,7 +113,9 @@
          d_t(i,klev+1-k) = dtime*pdtdt(i,k)
          pustr(i)        = pustr(i)
-     .                    +rg*pdudt(i,k)*(papmh(i,k+1)-papmh(i,k))
+cIM BUG  .                +rg*pdudt(i,k)*(papmh(i,k+1)-papmh(i,k))
+     .                    +pdudt(i,k)*(papmh(i,k+1)-papmh(i,k))/RG
          pvstr(i)        = pvstr(i)
-     .                    +rg*pdvdt(i,k)*(papmh(i,k+1)-papmh(i,k))
+cIM BUG  .                +rg*pdvdt(i,k)*(papmh(i,k+1)-papmh(i,k))
+     .                    +pdvdt(i,k)*(papmh(i,k+1)-papmh(i,k))/RG
       ENDDO
       ENDDO
@@ -1402,7 +1404,9 @@
          d_t(i,klev+1-k) = dtime*pdtdt(i,k)
          pustr(i)        = pustr(i)
-     .                    +RG*pdudt(i,k)*(papmh(i,k+1)-papmh(i,k))
+cIM BUG .                 +RG*pdudt(i,k)*(papmh(i,k+1)-papmh(i,k))
+     .                    +pdudt(i,k)*(papmh(i,k+1)-papmh(i,k))/RG
          pvstr(i)        = pvstr(i)
-     .                    +RG*pdvdt(i,k)*(papmh(i,k+1)-papmh(i,k))
+cIM BUG .                 +RG*pdvdt(i,k)*(papmh(i,k+1)-papmh(i,k))
+     .                    +pdvdt(i,k)*(papmh(i,k+1)-papmh(i,k))/RG
       ENDDO
       ENDDO
Index: /LMDZ4/trunk/libf/phylmd/phyetat0.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 644)
@@ -5,5 +5,8 @@
 c
       SUBROUTINE phyetat0 (fichnom,dtime,co2_ppm_etat0,solaire_etat0,
-     .            rlat,rlon, pctsrf, tsol,tsoil,deltat,qsurf,qsol,snow,
+     .            rlat,rlon, pctsrf, tsol,tsoil,
+cIM "slab" ocean
+     .           tslab,seaice,
+     .           qsurf,qsol,snow,
      .           albe, alblw, evap, rain_fall, snow_fall, solsw, sollw,
      .           fder,radsol,frugs,agesno,clesphy0,
@@ -32,12 +35,11 @@
       REAL tsol(klon,nbsrf)
       REAL tsoil(klon,nsoilmx,nbsrf)
-      REAL deltat(klon)
+cIM "slab" ocean
+      REAL tslab(klon), seaice(klon)
       REAL qsurf(klon,nbsrf)
       REAL qsol(klon)
       REAL snow(klon,nbsrf)
       REAL albe(klon,nbsrf)
-cIM BEG alblw
       REAL alblw(klon,nbsrf)
-cIM END alblw
       REAL evap(klon,nbsrf)
       REAL radsol(klon)
@@ -420,27 +422,53 @@
       ENDDO
 c
-c Lecture de deltat (pour slab ocean seulement):
-c
-      ierr = NF_INQ_VARID (nid, "DELTAT", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, "phyetat0: Le champ <DELTAT> est absent"
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, deltat)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, deltat)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, "phyetat0: Lecture echouee pour <DELTAT>"
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon
-         xmin = MIN(deltat(i),xmin)
-         xmax = MAX(deltat(i),xmax)
-      ENDDO
-      PRINT*,'Ecart de la SST deltat:', xmin, xmax
+cIM "slab" ocean 
+c
+c Lecture de tslab (pour slab ocean seulement):      
+c
+      ierr = NF_INQ_VARID (nid, "TSLAB", nvarid)
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, "phyetat0: Le champ <TSLAB> est absent"
+         CALL abort
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tslab)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, tslab)
+#endif
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, "phyetat0: Lecture echouee pour <TSLAB>"
+         CALL abort
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(tslab(i),xmin)
+         xmax = MAX(tslab(i),xmax)
+      ENDDO
+      PRINT*,'Ecart de la SST tslab:', xmin, xmax
+c
+c Lecture de seaice (pour slab ocean seulement):
+c
+      ierr = NF_INQ_VARID (nid, "SEAICE", nvarid)
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, "phyetat0: Le champ <SEAICE> est absent"
+         CALL abort
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, seaice)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, seaice)
+#endif
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, "phyetat0: Lecture echouee pour <SEAICE>"
+         CALL abort
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(seaice(i),xmin)
+         xmax = MAX(seaice(i),xmax)
+      ENDDO
+      PRINT*,'Masse de la glace de mer seaice:', xmin, xmax
 c
 c Lecture de l'humidite de l'air juste au dessus du sol:
@@ -652,5 +680,4 @@
 
 c
-cIM BEG alblw
 c Lecture de albedo au sol LW:
 c
@@ -690,7 +717,4 @@
          ENDDO
       ENDIF
-
-cIM END alblw
-
 c
 c Lecture de evaporation:  
Index: /LMDZ4/trunk/libf/phylmd/phyredem.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 644)
@@ -4,5 +4,8 @@
 c
       SUBROUTINE phyredem (fichnom,dtime,radpas,
-     .           rlat,rlon, pctsrf,tsol,tsoil,deltat,qsurf,qsol,snow,
+     .           rlat,rlon, pctsrf,tsol,tsoil,
+cIM "slab" ocean
+     .           tslab,seaice,
+     .           qsurf,qsol,snow,
      .           albedo, alblw, evap, rain_fall, snow_fall,
      .           solsw, sollw,fder,
@@ -31,5 +34,6 @@
       REAL tsol(klon,nbsrf)
       REAL tsoil(klon,nsoilmx,nbsrf)
-      REAL deltat(klon)
+cIM "slab" ocean
+      REAL tslab(klon), seaice(klon)
       REAL qsurf(klon,nbsrf)
       REAL qsol(klon)
@@ -288,10 +292,10 @@
       ENDDO
 c
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "DELTAT", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "DELTAT", NF_FLOAT, 1, idim2,nvarid)
+cIM "slab" ocean
+      ierr = NF_REDEF (nid)
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid, "TSLAB", NF_DOUBLE, 1, idim2,nvarid)
+#else
+      ierr = NF_DEF_VAR (nid, "TSLAB", NF_FLOAT, 1, idim2,nvarid)
 #endif
       ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 33,
@@ -299,7 +303,22 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,deltat)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,deltat)
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tslab)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,tslab)
+#endif
+c
+      ierr = NF_REDEF (nid)
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid, "SEAICE", NF_DOUBLE, 1, idim2,nvarid)
+#else
+      ierr = NF_DEF_VAR (nid, "SEAICE", NF_FLOAT, 1, idim2,nvarid)
+#endif
+      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 33,
+     .                        "Glace de mer kg/m2 (pour slab-ocean)")
+      ierr = NF_ENDDEF(nid)
+#ifdef NC_DOUBLE
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,seaice)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,seaice)
 #endif
 c
